//===================================================== ENCODEUR ====================================================================//

#include "RotaryEncoder.h"            // Utilise librairie RotaryEncoder
RotaryEncoder encoder(A10, A9);        // ("DT" dans -> A2 Arduino, "CLK" dans -> A3 Arduino)
long LastPosEnc = 0;            // Initialise la position de l'encodeur sur -> 0
long PosActuEnc;                      // Variable "Position Actuel de l'Encodeur" type long : 2 147 483 647 








//==================================================== BOUTON DROIT =================================================================//

const int pinBouton = 16;             // Constante -> pinBouton sur Pin 8 Arduino
bool etatBouton = 1;                  // Variable Hight/Low de l'état du pinBouton -> Au repos est = 1 (Hight/True)
int multiSpeed = 1;                   // Multiplicateur de vitesse







//======================================================== MOTEUR XYZR ==============================================================//

#include <AccelStepper.h>             // Utilise librairie AccelStepper

#define XdirPin 5    // Moteur X -> Direction pin 5
#define YdirPin 6    // Moteur Y -> Direction pin 6
#define ZdirPin 7    // Moteur Z -> Direction pin 7
#define RdirPin 13   // Moteur R -> Direction pin 7
#define XstepPin 2   // Moteur X -> Stepper pin 2
#define YstepPin 3   // Moteur Y -> Stepper pin 3
#define ZstepPin 4   // Moteur Z -> Stepper pin 4
#define RstepPin 12  // Moteur R -> Stepper pin 4
#define motorInterfaceType 1 // Interface 1 pour le Driver A4988

AccelStepper moteurX = AccelStepper(motorInterfaceType, XstepPin, XdirPin);    //Creé instance avec nom du moteurX
AccelStepper moteurY = AccelStepper(motorInterfaceType, YstepPin, YdirPin);    //Creé instance avec nom du moteurY
AccelStepper moteurZ = AccelStepper(motorInterfaceType, ZstepPin, ZdirPin);    //Creé instance avec nom du moteurZ
AccelStepper moteurR = AccelStepper(motorInterfaceType, RstepPin, RdirPin);    //Creé instance avec nom du moteurR

const int vitesseMaxMoteur = 12000;

int vitesseMoteurZ = 0;
int multiXY = 1;
int compMultiXY = 0;
int compMultiXYBis = 0;
const int enX = 31; // Pin "EN" du controleur X dans pin Arduino -> 31
const int enY = 32; // Pin "EN" du controleur Y dans pin Arduino -> 32
const int enZ = 30; // Pin "EN" du controleur Z dans pin Arduino -> 30
const int enR = 33; // Pin "EN" du controleur R dans pin Arduino -> 33

unsigned int XYRboucle = 0;
unsigned long tempsXYR = 0;
unsigned long tempsXYR2 = 0;

unsigned int appBtR = 0;






//====================================================== JOYSTIK ====================================================================//

int YjoyAct = 0;
long YJoyMap = 0; //int long?
int Yemission =0;

int XjoyAct = 0;
long XJoyMap = 0; //int long?
int Xemission =0;








//=========================================== DECLENCHEMENT PHOTO BOUTON GAUCHE =====================================================//

bool etatBoutonG = 1;
bool dernEtatBtG = 1;                  // Variable Hight/Low du dernier état du pinBouton 

const int pinBoutonG = 15;

int declFocus = 20;
int declPhoto = 21;









//================================================== SERIAL + BLUETOOTH =============================================================//

#include <SoftwareSerial.h>
SoftwareSerial bluetooth(52,53);      // (RX, TX) (pin Rx BT, pin Tx BT)
char messageRec;                         // Variable charactere message echanger Bluetooth <-> Arduino
String messageBT;                     // Variable a virgule envoyer à MIT pour position moteur YX -> PasY,PasX
String stringBtPas;
bool boucleString = 0;
bool arretTemps = 0;









//================================================== REMPLACEMENT DELAY =============================================================//

unsigned long lgUpdateTime;











//====================================================== MIT APP ====================================================================//

int long BtA = 0;
int long BtB = 0;

bool boucleMitR=0;









//====================================================== FOCUS STACKING ============================================================//

int att = 0;
int nmbPas = 0;
bool compG1 = 0;
bool compG2 = 0;
bool compG3 = 0;
int long distAB = 0;
int boucleZ = 0;
int multiZ = 1;
int compteurZ = 0;

unsigned int nmbPhotoTotal = 0;
unsigned int nmbPhotoFaite = 0;
bool vib = 0;      // capteur vibration vrai ou faux
bool comptVib = 0; // compteur si vibration X1
int vibPin = 48;
long tempsSiVib = 0;
int tempsSiVib2 = 0;






//============================================================= RESET ==============================================================//

int resetR = 0;
int resetXY = 0;
int resetZ = 0;






//====================================================== CATEUR FIN COURSE ==========================================================//

bool finXpos = 1;
const int pinFinCourseX = 39;





//====================================================== LAMPE ==========================================================//

const int lampe1 = 22;  // IN Lampe 1 sur pin 22
const int lampe2 = 23;  // IN Lampe 2 sur pin 23 
const int lampe3 = 24;  // IN Lampe 3 sur pin 24
const int lampe4 = 25;  // IN Lampe 4 sur pin 25
bool etatLampe1 = 0;
bool etatLampe2 = 0;
bool etatLampe3 = 0;
bool etatLampe4 = 0;
bool btLampe1 = 0;
bool btLampe2 = 0;
bool btLampe3 = 0;
bool btLampe4 = 0;
unsigned int comptLampe1 = 0;
unsigned int comptLampe2 = 0;
unsigned int comptLampe3 = 0;
unsigned int comptLampe4 = 0;







//====================================================== PEDALE ==========================================================//

const int piedD = 47; // Pédal bouton droite file vert
const int piedC = 49; // Pédal bouton centre file noir
const int piedG = 51; // Pédal bouton gauche file blanc
bool etatBtPd = 1;    // variable bool -> 1 ou 0 -->  1 = Bouton levé   // --> 0 = Bouton baissé
bool etatBtPc = 1;
bool etatBtPg = 1;
int vitesseMoteurR = 50; // Initialisation vitesse moteur R à 50





//===================================================================================================================================//
//======================================================    VOID SETUP   ============================================================//
//===================================================================================================================================//


void setup() {

  Serial.begin(115200);                      // Ouvre le port série USB avec vitesse 9600 bauds
  Serial.println(LastPosEnc);                // Ecrit la Position actuel de l'encodeur qui est -> "0"
  bluetooth.begin(115200);                   // Ouvre le port série BlueT avec vitesse 115200 bauds
  //bluetooth.setTimeout(100);
    
  moteurY.setCurrentPosition(0);             // Définie la position du moteurY sur -> "O"
  moteurX.setCurrentPosition(0);
  moteurZ.setCurrentPosition(0);
  moteurR.setCurrentPosition(0);
  moteurY.setMaxSpeed(vitesseMaxMoteur);     // Limite max du moteurXYZ en Pas/sec (Micro Pas 1/16, 3200 Pas pour 1 tour moteurY)
  moteurX.setMaxSpeed(vitesseMaxMoteur);
  moteurZ.setMaxSpeed(vitesseMaxMoteur);
  moteurR.setMaxSpeed(vitesseMaxMoteur);
  moteurZ.setAcceleration(1000);

  vitesseMoteurZ = 500;
  
  pinMode(pinBouton,INPUT_PULLUP);           // Indique pin pinBouton (8) Arduino est en Input et resistance Pullup
  pinMode(pinBoutonG,INPUT_PULLUP);          // Indique pin pinBouton (8) Arduino est en Input et resistance Pullup

  pinMode(declFocus, OUTPUT);
  pinMode(declPhoto, OUTPUT);


//--------PIN ENABLE---------//--> Activation des 4 "EN" sur le 4 controleur
  pinMode(enX, OUTPUT);      //
  pinMode(enY, OUTPUT);      // 
  pinMode(enZ, OUTPUT);      // 
  pinMode(enR, OUTPUT);      //
  digitalWrite(enX,LOW);     //
  digitalWrite(enY,LOW);     //
  digitalWrite(enZ,LOW);     // 
  digitalWrite(enR,LOW);     //
//---------------------------//

  pinMode (pinFinCourseX, INPUT_PULLUP);        // Pin pour le capteur fin de course

  pinMode (vibPin, INPUT);                      // Pin 39 va resevoir ou non 5V (pas de pullup interne?)

//-----------PIN LAMPE----------//
  pinMode(lampe1, OUTPUT);      //
  pinMode(lampe2, OUTPUT);      // 
  pinMode(lampe3, OUTPUT);      // 
  pinMode(lampe4, OUTPUT);      //
  digitalWrite(lampe1,HIGH);    //  !ATTENTION! INVERSE -> HIGH = éteint      LOW = allumé !!
  digitalWrite(lampe2,HIGH);    //
  digitalWrite(lampe3,HIGH);    // 
  digitalWrite(lampe4,HIGH);    //
//------------------------------//  


//-------------PEDAL-----------// --> 0 False Bouton baissé = 0V  // --> 1 True Bouton levé = 5V
  pinMode(piedD,INPUT_PULLUP); // --> Déclaration en INPUT_PULLUP
  pinMode(piedC,INPUT_PULLUP); //
  pinMode(piedG,INPUT_PULLUP); //
//-----------------------------//


messBtReset (); // Envoie par Bluethoot "RESET" en 5eme position






  
  } // Fin Setup










//===================================================================================================================================//
//=======================================================    VOID LOOP   ============================================================//
//===================================================================================================================================//



void loop() {



                         //-------------------------------------------------------------//
                        /////////////////////******Joystick *******//////////////////////
//---------------------//-------------------------------------------------------------//--------------------------------------------//


const int vitesseMoteur = 2000; //4000
const int zoneMorte = 250; //250
const int intervalJoy = 2; //5



  XjoyAct = analogRead(A11);  //  Read Potentiometer current XjoyActue
  YjoyAct = analogRead(A12);  //  Read Potentiometer current YjoyActue

  XJoyMap = map(XjoyAct, 389, 636, -vitesseMoteur, vitesseMoteur);  // Map XjoyActue
  YJoyMap = map(YjoyAct, 395, 635, -vitesseMoteur, vitesseMoteur);  


//==============================================================//
   if (YJoyMap > Yemission+intervalJoy){                     //
   Yemission = YJoyMap;                                      //
 }                                                              //  
                                                                //  
  if (Yemission > YJoyMap+intervalJoy){                      //
  Yemission = YJoyMap;                                       //
  }                                                             //
                                                                //
   if ((Yemission <= zoneMorte) && (Yemission >= -zoneMorte)){  //
      Yemission = 0;                                            //
     }                                                          //
//==============================================================//


//==============================================================//
   if (XJoyMap > Xemission+intervalJoy){                     //
   Xemission = XJoyMap;                                      //
 }                                                              //
                                                                //
  if (Xemission > XJoyMap+intervalJoy){                      //    
  Xemission = XJoyMap;                                       //
  }                                                             //  
                                                                //
   if ((Xemission <= zoneMorte) && (Xemission >= -zoneMorte)){  //
      Xemission = 0;                                            //
     }                                                          //
//==============================================================//

//Serial.print("Y=");
//Serial.print(YjoyAct); // YJoyMap     Yemission     YjoyAct
//Serial.print("   X=");
//Serial.println(XjoyAct); // XJoyMap   Xemission   XjoyAct
//if (Yemission != 0){Serial.print("Y EMMISSION = ");Serial.println(Yemission);} //TEMPORAIRE
//if (Yemission != 0){Serial.print("analogRead(A12) = ");Serial.println(analogRead(A12));} //TEMPORAIRE
//if (Xemission != 0){Serial.print("analogRead(A11) = ");Serial.println(analogRead(A11));} //TEMPORAIRE
//delay (100);









                         //--------------------------------------------------------------//
                        /////////////////////****** ENCODEUR *******//////////////////////
//---------------------//--------------------------------------------------------------//-------------------------------------------// 

encoder.tick();                                   // Interrogation position encodeur                              
PosActuEnc = encoder.getPosition()*multiSpeed;    // Initialisation de la variable "PosActuEnc" sur la position de l'encodeur









                         //------------------------------------------------------------------------//
                        /////////////////////****** RESET + REMISE A 0 *******//////////////////////
//---------------------//------------------------------------------------------------------------//---------------------------------//
  
long limiteVarPos = 2147400000;                                                                  
long limiteVarNeg = -2147400000;                                                                 

//========================== RESET==============================================//                                                                          
  if (resetR==1){                // Si MIT reset R, alors                       //       
  moteurR.setCurrentPosition(0); // Définie la position du moteur R sur -> "O"  //       
  resetR = 0;                                                                   //               
  }                                                                             //
  if (resetXY==1){               // Pareil pour Moteur XY                       //
  moteurX.setCurrentPosition(0);                                                //  
  moteurY.setCurrentPosition(0);                                                //  
  resetXY = 0;                                                                  //                
  }                                                                             //
  if (resetZ==1 || etatBouton == 0){ // MIT reset Z + PAD multispeed            //
  encoder.setPosition(0);            // Définir la posi. de l'encodeur sur "0"  // 
  moteurZ.setCurrentPosition(0);                                                //  
  resetZ = 0;                                                                   //               
  }                                                                             //
//==============================================================================//


                                                                                                                                                                                              
//=======SECURITE DEPACE LIMITE=====//                                                                                               
//===Pour l'Encodeur et le moteur===//                                                           
  if (PosActuEnc >= limiteVarPos){                                                               
  encoder.setPosition(0);                                                                                       
  moteurZ.setCurrentPosition(0);                                                                 
  }                                                                                              
                                                                                                 
  if (PosActuEnc <= limiteVarNeg){                                                               
  encoder.setPosition(0);                                                                            
  moteurZ.setCurrentPosition(0);                                                                 
  }                                                                                               
                                                                                                 










                         //---------------------------------------------------------------*----//
                        /////////////////////****** MULTISPEED PAD *******//////////////////////
//---------------------//--------------------------------------------------------------------//-------------------------------------//  

etatBouton = digitalRead (pinBouton);   // Repasse toujours pas ici -> etatBouton reprend toujours la valeur "pinBouton" 0 ou 1
                                        // "1" -> Bouton levé (NON APPUYE)    "0" -> Bouton baissé (APPUYE)
                                        

  if (!etatBouton) {          // Si etat Bt est faux OU si etatBouton est == 0 -> Appuyé
    
    delay(500);               // delay pour rebond bouton
    switch (multiSpeed) {     // check current value of step_speed and change it
      case 1:
        multiSpeed = 10;
        vitesseMoteurZ = 2000;      // medium speed
        messBtZ10();               // Envoye par Bluethoot "Zdix"
        break;
      case 10:
        multiSpeed = 100;
        vitesseMoteurZ = 3000;     // fast speed
        messBtZ100();               // Envoye par Bluethoot "Zcent"
        break;
      case 100:
        multiSpeed = 1;
        vitesseMoteurZ = 500;        // slow speed
        messBtZ1();               // Envoye par Bluethoot "Zun"
        break;
    }//Fin switch
    
  Serial.print("multi X"); Serial.println(multiSpeed);
  }//Fin etatBouton









                         //---------------------------------------------------------------------------//
                        ///////////////////////****** PEDALE MULTISPEED *******////////////////////////
//---------------------//---------------------------------------------------------------------------//------------------------------//

etatBtPc = digitalRead (piedC); // variable bool etatBtPc -> sur -> lecture position bouton pied central "piedC"

  if(!etatBtPc){                // si etatBtc est faux/false/0 (bouton baissé), alors ...
    delay(500);                 // delay pour rebond bouton
   
    switch (vitesseMoteurR) {   // check current value of step_speed and change it
      case 1:
        vitesseMoteurR = 50 ;   // medium speed
        messBtR50();
        break;
      case 50:
        vitesseMoteurR = 100 ;  // fast speed
        messBtR100();
        break;
      case 100:
        vitesseMoteurR = 1 ;    // slow speed
        messBtR1();
        break;
    }//Fin switch
  Serial.print("Vitesse Moteur R = ");
  Serial.println(vitesseMoteurR);
    
  }//Fin if



//------------- Si appuis MIT Bouton R ----------------

  if (appBtR == 1){
    if (vitesseMoteurR == 1   && boucleMitR==0 ) {vitesseMoteurR = 50;  boucleMitR=1;}
    if (vitesseMoteurR == 50  && boucleMitR==0 ) {vitesseMoteurR = 100; boucleMitR=1;}
    if (vitesseMoteurR == 100 && boucleMitR==0 ) {vitesseMoteurR = 1;   boucleMitR=1;}
    
  appBtR=0;
  Serial.print("Vitesse Moteur R = ");
  Serial.println(vitesseMoteurR);
  }//Fin if appBtr
  boucleMitR=0;










                         //-------------------------------------------------------------------------------//
                        //////////////////////////****** BOUTON GAUCHE *******/////////////////////////////
                       //////////////////////////****** DECLENCHEMENT *******/////////////////////////////                       
//--------------------//-------------------------------------------------------------------------------//----------------------------//

etatBoutonG = digitalRead (pinBoutonG);   // Repasse toujours pas ici -> etatBouton reprend toujours la valeur "pinBouton" 0 ou 1
                                          // "1" -> Bouton levé (NON APPUYE)    "0" -> Bouton baissé (APPUYE)  

//Serial.println(etatBoutonG);

  if (etatBoutonG ==0 && dernEtatBtG ==1){decl();}

  if (etatBoutonG ==1 && dernEtatBtG ==0){dernEtatBtG = etatBoutonG;}    // Quand on relache le bouton A



  




                             //------------------------------------------------------------------------//
                            //////////////////////////****** MOTEUR *******/////////////////////////////
//-------------------------//------------------------------------------------------------------------//-----------------------------//

// Moteur : 200 pas -> avec micro pas 1/16 -> 3200 pas par tour
// Moteur : 360deg = 3200 pas   //   135deg = 2400 pas  //  90deg = 1600 pas  //  45deg = 800 pas
// Quans appuye sur bouton -> remise a 0 moteur -> Voir section Encoder


long pasMoteurZ = moteurZ.currentPosition();             // Initialisation variable "pasMoteurZ" sur la position actuel du moteur
long pasMoteurY = moteurY.currentPosition();             // Variable Pas Moteur de type long -2 147 483 648 à 2 147 483 647
long pasMoteurX = moteurX.currentPosition();
long pasMoteurR = moteurR.currentPosition();



//------------------------------------- Moteur Z ---------------------------------------------//
                                                                                              //
  if (PosActuEnc != pasMoteurZ){                                                              //
  Yemission = 0;
  Xemission = 0;  
  moteurZ.moveTo(PosActuEnc);           // Définie la cible sur la variable "PosActuEnc"      //
  moteurZ.setSpeed(vitesseMoteurZ);     // Définie la vitesse pour aller a la cible           //
  moteurZ.runSpeedToPosition();         // Va à la position Cilbe, avec la vitesse définit    //
  }                                                                                           //
                                                                                              //  
//--------------------------------------------------------------------------------------------//   




//----------- MOTEUR JOYSTICK XY --------------//
                                               //
//***************** X *******************//    //
                                         //    //
finXpos = digitalRead(pinFinCourseX);    //    //
moteurX.setSpeed (Xemission/multiXY);    //    //
                                         //    //
//-------FIN DE COURSE X+------//        //    //
if (finXpos==0){               //        //    //
  if (Xemission>=0){}          //        //    //
  else{moteurX.runSpeed();}    //        //    //
  }                            //        //    //
                               //        //    //
else {moteurX.runSpeed();}     //        //    //
//-----------------------------//        //    //
                                         //    //
                                         //    //
//***************** Y *******************//    //                                   
moteurY.setSpeed (Yemission/multiXY);    //    //
                                         //    //
                                         //    //
moteurY.runSpeed();                      //    //
                                         //    //
//=======================================//    //
                                               //
//---------------------------------------------//






//---------------------------------------------------- MOTEUR R ----------------------------------------------------------//
etatBtPd = digitalRead (piedD);     // variable bool etatBtPd -> sur -> lecture position bouton pied droit "piedD"        //
etatBtPg = digitalRead (piedG);     // variable bool etatBtPg -> sur -> lecture position bouton pied gauche "piedG"       //
                                                                                                                          //
                                                                                                                          //
if (!etatBtPd && etatBtPg==1){      // si etatBtd est faux/false/0 (bouton baissé), (sécu-> et etatBtPg à 1) alors ...    //
  moteurR.setSpeed(vitesseMoteurR); // définis vitesse à la variable "vitesseMoteurR"                                     //
  moteurR.runSpeed();               // tourne a la vitesse de 50 (1 pas par un pas -> fonction non bloquante)             //
}                                                                                                                         //
                                                                                                                          //
if (!etatBtPg && etatBtPd==1){       // si etatBtg est faux/false/0 (bouton baissé), (sécu-> et etatBtPd à 1) alors ...   //
  moteurR.setSpeed(-vitesseMoteurR); // définis vitesse à la variable "vitesseMoteurR"                                    //
  moteurR.runSpeed();                // tourne a la vitesse de 50 (1 pas par un pas -> fonction non bloquante)            //
}                                                                                                                         //
//------------------------------------------------------------------------------------------------------------------------//




//------------------------------------------------------------------//



//-------------------MULTI XY / Bouton App / Bouton Droit--------------------------------//
if      (compMultiXY==1 && compMultiXYBis==0){multiXY=2;  compMultiXY=0; compMultiXYBis=1;}
else if (compMultiXY==1 && compMultiXYBis==1){multiXY=5;  compMultiXY=0; compMultiXYBis=2;}
else if (compMultiXY==1 && compMultiXYBis==2){multiXY=10; compMultiXY=0; compMultiXYBis=3;}
else if (compMultiXY==1 && compMultiXYBis==3){multiXY=1;  compMultiXY=0; compMultiXYBis=0;}
//---------------------------------------------------------------------------------------//

//  if (compMultiXY==1) {
    
//    switch (multiXY) {     // check current value of step_speed and change it
//      case 1:
//        multiXY = 2; compMultiXY=0;
//        break;
//      case 2:
//        multiXY = 5; compMultiXY=0;
//        break;
//      case 5:
//        multiXY = 10; compMultiXY=0;
//        break;        
//      case 10:
//        multiXY = 1; compMultiXY=0;
//        break;
//    }//Fin switch
    
//  }//Fin compMultiXY






//Serial.print("Y=");
//Serial.print(Yemission);
//Serial.print("   X=");
//Serial.println(Xemission);
//delay (500);



//-------------------------------------------- Désactication XYR moteur 30s ------------------------------------------------//

if(Yemission==0 && Xemission==0 && XYRboucle==0 && etatBtPd==1 && etatBtPc==1 && etatBtPg==1 ){
  tempsXYR=millis();XYRboucle=1;
  }

if(millis()-tempsXYR==30000 && XYRboucle==1){ //30s avant desac
  desaMotXYR();
  XYRboucle=2;
  Serial.println("Desactivation");
  delay(100);
  }

if((Yemission!=0 || Xemission!=0 || etatBtPd==0 || etatBtPc==0 || etatBtPg==0) && XYRboucle==1){
  XYRboucle=0;
  }

if((Yemission!=0 || Xemission!=0 || etatBtPd==0 || etatBtPc==0 || etatBtPg==0) && XYRboucle==2){
  actiMotXYR();
  XYRboucle=0;
  Serial.println("Activation");
  delay(100);
  }

//-------------------------------------------------------------------------------------------------------------------------//







                            

                           //--------------------------------------------------------------------------------//
                          //////////////////////////****** FOCUS STACKING *******/////////////////////////////
//-----------------------//--------------------------------------------------------------------------------//-----------------------//

//nmbPhotoTotal = (BtA-BtB)/nmbPas;
vib = digitalRead(vibPin);


//-----Si pas en position A-> Aller en A >  Sinon-> Passer en l'étape suivante----------->


  if(compG1==1 && pasMoteurZ!=BtA){
    desaMotXYR();
    moteurZ.moveTo(BtA);                               // Définie la cible sur BtA   
    moteurZ.setSpeed(5000);                            // Définie la vitesse pour aller a la cible
    moteurZ.runSpeedToPosition();                      // Va a posi. cilbe -> 1 pas par loop
    encoder.tick();
    encoder.setPosition(moteurZ.currentPosition());    // Définit encodeur sur pas moteur Z
    multiSpeed = 1;
    } //Fin CompG1
  else if(compG1==1 && pasMoteurZ==BtA){nmbPhotoFaite=0; messBT(); compG1=0; compG2=1; delay (1000);}




  //=========================================== SI A < B ===========================================================//

  if(compG2==1){
   
    if (BtA < BtB){
      while (moteurZ.currentPosition() < BtB){
      moteurZ.setCurrentPosition(moteurZ.currentPosition());
      moteurZ.move(nmbPas);               // Définie la cible sur le nombre de pas selection sur MIT    
      moteurZ.runToPosition();         // Va à la position Cilbe, avec la vitesse définit
      messBT();

      //--------------ATTENTE seconde de "ATT" AVANT DECL -> SI VIB + ATT S-------------------------//
      tempsSiVib =  millis();
      
        while (tempsSiVib2 < att){
        tempsSiVib2 =  millis()-tempsSiVib ;
              if (digitalRead(vibPin)==0){messBtVib(); comptVib=1; tempsSiVib = millis();}//Fin if vib
        Serial.println(tempsSiVib2);      
        }//Fin while tempsSiSib2
      
      tempsSiVib2 = 0;
      if (comptVib==1){messBtNoVib();comptVib=0;}
      
      //decl ();                   // Prise photo
      
      nmbPhotoFaite++;
      messBT();
      delay (500);// Delay temps de pause Max -> 1s!
      } //Fin While
     } //Fin BtA > BtB

   
  //=========================================== SI A > B ===========================================================//

      if (BtA > BtB){
        while (moteurZ.currentPosition() > BtB){
        moteurZ.setCurrentPosition(moteurZ.currentPosition());
        moteurZ.move(-nmbPas);               // Définie la cible sur le nombre de pas selection sur MIT    
        moteurZ.runToPosition();          // Va à la position Cilbe, avec la vitesse définit 
        messBT();        

      //--------------ATTENTE seconde de "ATT" AVANT DECL -> SI VIB + ATT S-------------------------//
      tempsSiVib =  millis();
      
        while (tempsSiVib2 < att){
        tempsSiVib2 =  millis()-tempsSiVib ;
              if (digitalRead(vibPin)==0){messBtVib(); comptVib=1; tempsSiVib = millis();}//Fin if vib
        Serial.println(tempsSiVib2);      
        }//Fin while tempsSiSib2
      
      tempsSiVib2 = 0;
      if (comptVib==1){messBtNoVib();comptVib=0;}
      
       //decl ();                   // Prise photo
      
        nmbPhotoFaite++;
        messBT();
        delay (500);               // Delay temps de pause Max -> 1s!
        } //Fin While
      } //Fin BtA > BtB
  
  //------------------------------------------------------------------------------------------------------------//

 
  compG2=0;
  encoder.tick();
  encoder.setPosition(moteurZ.currentPosition());
  actiMotXYR();
  messBT();
  delay (100);
 
  } //Fin CompG2
 



  




                           //--------------------------------------------------------------------------------//
                          /////////////////////////////****** LAMPES *******//////////////////////////////////
//-----------------------//--------------------------------------------------------------------------------//-----------------------//

etatLampe1 = digitalRead(lampe1);
etatLampe2 = digitalRead(lampe2);
etatLampe3 = digitalRead(lampe3);
etatLampe4 = digitalRead(lampe4);

//---------------LAMPE 1--------------//
  if (comptLampe1==4){digitalWrite(lampe1, HIGH); btLampe1=0; comptLampe1=0;}
  if (btLampe1==1 && comptLampe1==1){digitalWrite(lampe1, LOW);btLampe1=0;}
  if (btLampe1==1 && comptLampe1<4) {digitalWrite(lampe1, HIGH); delay(300); digitalWrite(lampe1, LOW); btLampe1=0;} 

//---------------LAMPE 2--------------//
  if (comptLampe2==4){digitalWrite(lampe2, HIGH); btLampe2=0; comptLampe2=0;}
  if (btLampe2==1 && comptLampe2==1){digitalWrite(lampe2, LOW);btLampe2=0;}
  if (btLampe2==1 && comptLampe2<4) {digitalWrite(lampe2, HIGH); delay(300); digitalWrite(lampe2, LOW); btLampe2=0;}
  
//---------------LAMPE 3--------------//
  if (comptLampe3==4){digitalWrite(lampe3, HIGH); btLampe3=0; comptLampe3=0;}
  if (btLampe3==1 && comptLampe3==1){digitalWrite(lampe3, LOW);btLampe3=0;}
  if (btLampe3==1 && comptLampe3<4) {digitalWrite(lampe3, HIGH); delay(300); digitalWrite(lampe3, LOW); btLampe3=0;} 

//---------------LAMPE 4--------------//
  if (comptLampe4==4){digitalWrite(lampe4, HIGH); btLampe4=0; comptLampe4=0;}
  if (btLampe4==1 && comptLampe4==1){digitalWrite(lampe4, LOW);btLampe4=0;}
  if (btLampe4==1 && comptLampe4<4) {digitalWrite(lampe4, HIGH); delay(300); digitalWrite(lampe4, LOW); btLampe4=0;}








                             //---------------------------------------------------------------------------//
                            //////////////////////////****** Bluetooth *******/////////////////////////////
//-------------------------//---------------------------------------------------------------------------//--------------------------//



  
//--------------------------ENVOIS TOUTE LES 100 MILLIS MESSAGE BLUETOOTH-------------------------------------

 if(millis() - lgUpdateTime > 100 && arretTemps==0) {lgUpdateTime = millis(); messBT();} //Loop approx every 100 milliseconds

//-------------------------------------------------------------------------------------------------------------






  if(bluetooth.available()){                          // Si Bluetooth recois qql ch
  messageRec = bluetooth.read();                      // lire le message recus et le stocker dans variable messageRec

    if(messageRec == 'A'){BtA=pasMoteurZ;nmbPhotoFaite=0;}
    if(messageRec == 'B'){BtB=pasMoteurZ;nmbPhotoFaite=0;}
    if(messageRec == 'P'){nmbPas++;}
    if(messageRec == 'V'){nmbPas--;}
    if(messageRec == 'C'){nmbPas=nmbPas+100;}
    if(messageRec == 'D'){nmbPas=nmbPas-100;}
    if(messageRec == 'M'){att = att+1000;}
    if(messageRec == 'N'){att = att-1000;}
    if(messageRec == 'G'){compG1 = 1;}                 //<-FOCUS STACKING
    if(messageRec == 'E'){compMultiXY = 1;}            // MultiXY App
    if(messageRec == 'H'){btLampe1 = 1; comptLampe1++;}
    if(messageRec == 'I'){btLampe2 = 1; comptLampe2++;}
    if(messageRec == 'J'){btLampe3 = 1; comptLampe3++;}
    if(messageRec == 'F'){btLampe4 = 1; comptLampe4++;}
    if(messageRec == 'K'){appBtR = 1;}
    if(messageRec == 'R'){resetR = 1;}
    if(messageRec == 'L'){resetXY = 1;}
    if(messageRec == 'O'){resetZ = 1;}                   
    //Serial.print("BtA ");
    //Serial.println(BtA);
    //Serial.print("BtB ");
    //Serial.println(BtB);
    //Serial.print("nmbPas ");
    //Serial.println(nmbPas);
    //Serial.print("att ");
    //Serial.println(att);
    //Serial.print("compMultiXY ");
    //Serial.println(messageRec);  
    //delay (1000);

//------------------Si MIT PAS ECRIS A LA MAIN--------------------------------------------//
                                                                                          //
  if (messageRec=='$'){                                                                   //
   arretTemps = 1;   //Arrêt envoye bluethoot position moteur XYZR toute les 100mili.s    //
   boucleString = 1;                                                                      //
  }                                                                                       //
                                                                                          //
  if (boucleString==1){                                                                   //
    stringBtPas = stringBtPas + messageRec;                                               //
    Serial.print("stringBtPas = ");                                                       //
    Serial.println(stringBtPas);                                                          //
  }                                                                                       //
                                                                                          //
  if (messageRec=='*'){                                                                   //
    stringBtPas = stringBtPas.substring(1, stringBtPas.length()-1);                       //
    //Serial.print("stringBtPas* = ");                                                    //
    //Serial.println(stringBtPas);                                                        //
    nmbPas=stringBtPas.toInt();                                                           //
    Serial.print("nmbPas = ");                                                            //
    Serial.println(nmbPas);                                                               //
    arretTemps = 0;   //Reprise envoye bluethoot position moteur XYZR toute les 100mili.s //
    stringBtPas="";   // rénitialisation stringBtPas, quand reçois "*"                    //        
  }                                                                                       //
                                                                                          //
//----------------------------------------------------------------------------------------//

  } // Fin BT








} //----------> Fin Loop Arduino








//===================================================================================================================================//
//======================================================== FONCTION =================================================================//
//===================================================================================================================================//



//*************************MESSAGE BT*********************//
                                                          //
void messBT() {                                           //
                                                          // 
  messageBT = (String) moteurZ.currentPosition() + "," +  //
              (String) moteurX.currentPosition() + "," +  //
              (String) moteurY.currentPosition() + "," +  // 
              (String) moteurR.currentPosition() + "," +  // 
              (String) nmbPhotoFaite;                     //
                                                          //              
  Serial.println(messageBT);                              //
  bluetooth.println(messageBT);                           //
                                                          //  
  }  //Fin messBT                                         // 
                                                          //
//********************************************************//





//****************MESSAGE BT VIBRATION********************//
                                                          //
void messBtVib() {                                        //
                                                          //               
  messageBT = (String) moteurZ.currentPosition() + "," +  //
              (String) moteurX.currentPosition() + "," +  //
              (String) moteurY.currentPosition() + "," +  // 
              (String) moteurR.currentPosition() + "," +  //
              (String) "vibration";                       //
                                                          //              
  Serial.println(messageBT);                              //
  bluetooth.println(messageBT);                           //
                                                          //  
  }  //Fin messBT                                         // 
                                                          //
//********************************************************//
//****************** MESSAGE BT NOVIB ********************//
                                                          //
void messBtNoVib() {                                      //
                                                          //               
  messageBT = (String) moteurZ.currentPosition() + "," +  //
              (String) moteurX.currentPosition() + "," +  //
              (String) moteurY.currentPosition() + "," +  // 
              (String) moteurR.currentPosition() + "," +  //
              (String) "noVib";                           //
                                                          //              
  Serial.println(messageBT);                              //
  bluetooth.println(messageBT);                           //
                                                          //  
  }  //Fin messBT                                         // 
                                                          //
//********************************************************//




//****************MESSAGE BT RESET************************//
                                                          //
void messBtReset() {                                      //
                                                          //               
  messageBT = (String) moteurZ.currentPosition() + "," +  //
              (String) moteurX.currentPosition() + "," +  //
              (String) moteurY.currentPosition() + "," +  // 
              (String) moteurR.currentPosition() + "," +  //
              (String) "RESET";                           //
                                                          //              
  Serial.println(messageBT);                              //
  bluetooth.println(messageBT);                           //
                                                          //  
  }  //Fin messBT                                         // 
                                                          //
//********************************************************//







//==================================================================================================================================//
//*************************************************** MULTISPEED MOTEUR R **********************************************************//
//==================================================================================================================================//


//****************MESSAGE BT VITESSE RX1******************//
                                                          //
void messBtR1() {                                         //
                                                          //               
  messageBT = (String) moteurZ.currentPosition() + "," +  //
              (String) moteurX.currentPosition() + "," +  //
              (String) moteurY.currentPosition() + "," +  // 
              (String) moteurR.currentPosition() + "," +  //
              (String) "rUn";                      //
                                                          //              
  Serial.println(messageBT);                              //
  bluetooth.println(messageBT);                           //
                                                          //  
  }  //Fin messBT                                         // 
                                                          //
//********************************************************//
//****************MESSAGE BT VITESSE RX50*****************//
                                                          //
void messBtR50() {                                        //
                                                          //               
  messageBT = (String) moteurZ.currentPosition() + "," +  //
              (String) moteurX.currentPosition() + "," +  //
              (String) moteurY.currentPosition() + "," +  // 
              (String) moteurR.currentPosition() + "," +  //
              (String) "rCinquante";                      //
                                                          //              
  Serial.println(messageBT);                              //
  bluetooth.println(messageBT);                           //
                                                          //  
  }  //Fin messBT                                         // 
                                                          //
//********************************************************//
//****************MESSAGE BT VITESSE RX100****************//
                                                          //
void messBtR100() {                                       //
                                                          //               
  messageBT = (String) moteurZ.currentPosition() + "," +  //
              (String) moteurX.currentPosition() + "," +  //
              (String) moteurY.currentPosition() + "," +  // 
              (String) moteurR.currentPosition() + "," +  //
              (String) "rCent";                           //
                                                          //              
  Serial.println(messageBT);                              //
  bluetooth.println(messageBT);                           //
                                                          //  
  }  //Fin messBT                                         // 
                                                          //
//********************************************************//



//==================================================================================================================================//






//==================================================================================================================================//
//*************************************************** MULTISPEED MOTEUR XY *********************************************************//
//==================================================================================================================================//


//****************MESSAGE BT VITESSE Zx1******************//
                                                          //
void messBtZ1() {                                         //
                                                          //               
  messageBT = (String) moteurZ.currentPosition() + "," +  //
              (String) moteurX.currentPosition() + "," +  //
              (String) moteurY.currentPosition() + "," +  // 
              (String) moteurR.currentPosition() + "," +  //
              (String) "Zun";                             //
                                                          //              
  Serial.println(messageBT);                              //
  bluetooth.println(messageBT);                           //
                                                          //  
  }  //Fin messBT                                         // 
                                                          //
//********************************************************//
//****************MESSAGE BT VITESSE Zx10*****************//
                                                          //
void messBtZ10() {                                        //
                                                          //               
  messageBT = (String) moteurZ.currentPosition() + "," +  //
              (String) moteurX.currentPosition() + "," +  //
              (String) moteurY.currentPosition() + "," +  // 
              (String) moteurR.currentPosition() + "," +  //
              (String) "Zdix";                            //
                                                          //              
  Serial.println(messageBT);                              //
  bluetooth.println(messageBT);                           //
                                                          //  
  }  //Fin messBT                                         // 
                                                          //
//********************************************************//
//****************MESSAGE BT VITESSE Zx100****************//
                                                          //
void messBtZ100() {                                       //
                                                          //               
  messageBT = (String) moteurZ.currentPosition() + "," +  //
              (String) moteurX.currentPosition() + "," +  //
              (String) moteurY.currentPosition() + "," +  // 
              (String) moteurR.currentPosition() + "," +  //
              (String) "Zcent";                           //
                                                          //              
  Serial.println(messageBT);                              //
  bluetooth.println(messageBT);                           //
                                                          //  
  }  //Fin messBT                                         // 
                                                          //
//********************************************************//



//==================================================================================================================================//
//***DESACTIVATION MOTEUR XYR***//
void desaMotXYR() {             //  
  digitalWrite(enX,HIGH);       //
  digitalWrite(enY,HIGH);       //
  digitalWrite(enR,HIGH);       //   
}                               //  
//******************************//

//****ACTIVATION MOTEUR XYR*****//
void actiMotXYR() {             //  
  digitalWrite(enX,LOW);        //
  digitalWrite(enY,LOW);        //
  digitalWrite(enR,LOW);        //   
}                               //  
//******************************//



//---------------------------------------------//



//****DESACTIVATION 4 MOTEUR****//
void desaTousMot() {            //  
  digitalWrite(enX,HIGH);       //
  digitalWrite(enY,HIGH);       //
  digitalWrite(enZ,HIGH);       //  
  digitalWrite(enR,HIGH);       //   
}                               //  
//******************************//

//******ACTIVATION 4 MOTEUR*****//
void activTousMot() {           //  
  digitalWrite(enX,LOW);        //
  digitalWrite(enY,LOW);        //
  digitalWrite(enZ,LOW);        //  
  digitalWrite(enR,LOW);        //   
}                               //  
//******************************//



//---------------------------------------------//




    
//}//Fin void
